;Jan_s Mapeditor.de.vu Tutorial - Based on the Original Preview Sample
;es wurde absichtlcih sehr einfach gehalten!


;Als 1. Laden wir die MapLibary
;Jene muss im Unterverzeichniss "mapengine" sein.
;Diese ermglicht uns, einfach und schnell auf die Mapzuzugreifen.
Include "mapengine\mapengine.bb"

;Nun initialisieren wir unseren Grafikmodus
;initialisieren heit, das wir alle dinge die wir spter bentigen starten und einstellen
Graphics 800,600,32,2;Fenster erstellen
SetBuffer BackBuffer();Flimmerfrei schalten
MoveMouse GraphicsWidth()/2,GraphicsHeight()/2;Maussetzten

;Hier laden wir unsere Map.
;Jenes geschieht mit einer eigenen Function
;Siehe dazu etwas Weiter unten
;jene sind Hier im unterverzeichniss "map" abgelegt.
;BEACHTE:
;  die map muss IMMER im selben verzeichniss sein wie ihre Tilemap&Background(Grafiken)
;  dazu siehe den ordner Map
;  tile_jan.png=Tilemap
;  Jan1.map=Mapfile
;  bg_jan.PNG=Hintergrund
;  Mehere Maps Knnen Die Gleichen grafiken benutzen, und mehrere Grafiken knnen von 1ner Map benutzt werden.
LoadMap("map\jan1.map")
;eine andere Map ldt man, indem mann ihren Dateinamen mit unterordner von der ".bb" datei aus angibt
;z.B.
;  LoadMap("map\jan2.map"); diese ist auch schon vorhanden(zum testen auskommertieren und die zeile:"LoadMap("map\jan1.map")" kommertieren)
;Auskommertieren = das ";" am Anfang der Zeile entfernen --> kein Kommentar mehr
;Kommertieren ist vor die Zeile ein ";" zu machen --> wir vom Code zum Compiler unbeachteten Kommentar.



Repeat ;Hauptschleife
  
  If KeyHit(1) Then ende=True ; Hauptschleife beenden
  Steuerung() ; Unsere Steuerungsfunction (siehe ein Stck weiter unten)
  Cls ; Hintergrund lschen
  maplibary_update() ; Unsere MApLibary update Function (siehe ein Stck weiter unten) - nach CLS und Vor Flip 

  ;Nun noch etwas fr das Auge!
  ;eine Kleien Ausgabe, der Horizontalen und verticalen Position
  Text 0,0,"Position der Ansicht:"
  Text 0,20,"X:"+map_scrollx+"  Y:"+map_scrolly

  Flip
Until ende


Function Steuerung()
  ;map_scrollx und map_scrolly sind globale Variablen, welche von der MapLibary genutzt werden.
  ;Wenn wir diese verndern, verndern wir die Position der Map.

  ;Mit Tastatur vernder
  If KeyDown(200) Then map_scrolly=map_scrolly+10 ;up
  If KeyDown(208) Then map_scrolly=map_scrolly-10 ;down
  If KeyDown(203) Then map_scrollx=map_scrollx+10 ;left
  If KeyDown(205) Then map_scrollx=map_scrollx-10 ;right

  ;Mit Maus verndern
  mx=MouseXSpeed();aktuelle horizontale Geschwindigkeit der Maus
  my=MouseYSpeed();aktuelle verticale Geschwindigkeit der Maus
  MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
  map_scrollx=map_scrollx+mx ; die position um die Geschwindigkeit verschieben
  map_scrolly=map_scrolly+my ; die position um die Geschwindigkeit verschieben
End Function


;-------------------------------------------------------------------------------------------------------
;Diese Functionen knnt ihr ruhig bernehmen.
;Sie sollten bei den meisten 2D Spielen sehr gut Functionen
;-------------------------------------------------------------------------------------------------------

;Hier aktuallisieren wir die ansicht der Map
;dies muss in jeden Frame erfolgen
;Sie muss nach CLS und vor Flip stehen
Function MapUpdate()
  tile_animate() ;Animationen Berechnen
  map_draw() ;Alles Zeichnen
End Function

;Hier Laden wir die Karte in den Speicher
;und behandeln die Fehler, die beim Laden der Karte auftretten knnen.
Function LoadMap(Map$,pwd$="")
	error=map_load(map$,pwd) ; Laden der Karte

	;Fehlerbehandlung
	If error>0 Then EndGraphics
	Select error
	  Case 1
    	RuntimeError "File not found"
	  Case 2
    	RuntimeError "File size corrupted"
	  Case 3
    	RuntimeError "No read access"
	  Case 4
    	RuntimeError "Not valid file"
	  Case 5
    	RuntimeError "Checksum problem"
	  Case 6
    	RuntimeError "Password problem"
	  Case 7
    	RuntimeError "Load image problem"
	End Select
	If error>0 Then End
End Function
;-------------------------------------------------------------------------------------------------------